VERSION 5.00
Object = "{27395F88-0C0C-101B-A3C9-08002B2F49FB}#1.1#0"; "PICCLP32.OCX"
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "BlockPusher"
   ClientHeight    =   4215
   ClientLeft      =   60
   ClientTop       =   360
   ClientWidth     =   5805
   ClipControls    =   0   'False
   Icon            =   "blokpush.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   281
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   387
   StartUpPosition =   3  'Windows Default
   Begin PicClip.PictureClip PictureClip1 
      Left            =   4440
      Top             =   240
      _ExtentX        =   1693
      _ExtentY        =   1693
      _Version        =   393216
      Picture         =   "blokpush.frx":0442
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   0
      Left            =   0
      Top             =   0
      Width           =   240
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'tiles
'0=floor
'1=wall
'2=block
'3=you
'4=water
'5=exit
'6="real" wall
'7="fake" wall
'8=force n
'9=force e
'10=force s
'11=force w
'12=inv wall
'13=hidden wall
'14=popup wall
'15=blocktrap
'system only tiles
'16=you on wall


Dim Level(15, 15) As Byte
Dim Tiles(15, 15) As Byte
Dim YouX As Integer
Dim YouY As Integer

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
Select Case KeyCode
    Case vbKeyUp
        YouMove YouX, YouY - 1, YouX, YouY, 0
    Case vbKeyRight
        YouMove YouX + 1, YouY, YouX, YouY, 0
    Case vbKeyDown
        YouMove YouX, YouY + 1, YouX, YouY, 0
    Case vbKeyLeft
        YouMove YouX - 1, YouY, YouX, YouY, 0
    Case Asc("R") Or Asc("r")
        For I = 0 To 15
    For J = 0 To 15
        Level(I, J) = Tiles(I, J)
    Next J
Next I
        LocateYou
        Reload
End Select
End Sub

Private Sub LocateYou()
    For I = 15 To 0 Step -1
        For J = 15 To 0 Step -1
            If Level(I, J) = 3 Then
                YouX = I
                YouY = J
            End If
        Next J
    Next I
End Sub

Private Sub YouMove(NewX As Integer, NewY As Integer, OldX As Integer, OldY As Integer, ForceNum As Integer)
Dim OldYouX As Integer, OldYouY As Integer
If NewX < 0 Or NewX > 15 Then
Exit Sub
End If
OldYouX = YouX
OldYouY = YouY
If NewY < 0 Or NewY > 15 Then
Exit Sub
End If
Select Case Level(NewX, NewY)
    Case 0
        If Level(OldX, OldY) = 16 Then
            Level(OldX, OldY) = 1
        Else
            Level(OldX, OldY) = ForceNum
        End If
        YouX = NewX
        YouY = NewY
        Level(NewX, NewY) = 3
    Case 1
        'do nothing... you can't move
    Case 2
        PushBlock 2 * NewX - OldX, 2 * NewY - OldY, NewX, NewY, 0
        If Level(NewX, NewY) = 0 Then
        If Level(OldX, OldY) = 16 Then
            Level(OldX, OldY) = 1
        Else
            Level(OldX, OldY) = ForceNum
        End If
        YouX = NewX
        YouY = NewY
        Level(NewX, NewY) = 3
        End If
    Case 3
        'this shouldn't happen... if it does, treat it like a wall
    Case 4
        'you can't swim... you don't move
    Case 5
        MsgBox "You have won this level!"
    Case 6
        Level(NewX, NewY) = 1
    Case 7
        If Level(OldX, OldY) = 16 Then
            Level(OldX, OldY) = 1
        Else
            Level(OldX, OldY) = ForceNum
        End If
        YouX = NewX
        YouY = NewY
        Level(NewX, NewY) = 3
    Case 8
        YouMove NewX, NewY - 1, NewX, NewY, 8
        If Level(OldYouX, OldYouY) = 16 Then
            Level(OldYouX, OldYouY) = 1
        ElseIf Level(OldYouX, OldYouY) = 3 Then
            Level(OldYouX, OldYouY) = 0
        End If
    Case 9
        YouMove NewX + 1, NewY, NewX, NewY, 9
        If Level(OldYouX, OldYouY) = 16 Then
            Level(OldYouX, OldYouY) = 1
        ElseIf Level(OldYouX, OldYouY) = 3 Then
            Level(OldYouX, OldYouY) = 0
        End If
    Case 10
        YouMove NewX, NewY + 1, NewX, NewY, 10
        If Level(OldYouX, OldYouY) = 16 Then
            Level(OldYouX, OldYouY) = 1
        ElseIf Level(OldYouX, OldYouY) = 3 Then
            Level(OldYouX, OldYouY) = 0
        End If
    Case 11
        YouMove NewX - 1, NewY, NewX, NewY, 11
        If Level(OldYouX, OldYouY) = 16 Then
            Level(OldYouX, OldYouY) = 1
        ElseIf Level(OldYouX, OldYouY) = 3 Then
            Level(OldYouX, OldYouY) = 0
        End If
    Case 12
        'do nothing... the wall doesn't appear
    Case 13
        Level(NewX, NewY) = 1
    Case 14
        If Level(OldX, OldY) = 16 Then
            Level(OldX, OldY) = 1
        Else
            Level(OldX, OldY) = ForceNum
        End If
        YouX = NewX
        YouY = NewY
        Level(NewX, NewY) = 16
    Case 15
        'do nothing... you can't move here
    Case 16
        'this shouldn't happen... don't move
End Select
Reload
End Sub

Private Sub PushBlock(NewX, NewY, OldX, OldY, ForceConst As Byte)
Dim OldX2 As Byte
Dim OldY2 As Byte
If NewX < 0 Or NewX > 15 Then
Exit Sub
End If

If NewY < 0 Or NewY > 15 Then
Exit Sub
End If
Select Case Level(NewX, NewY)
    Case 0
        Level(NewX, NewY) = 2
        Level(OldX, OldY) = ForceConst
    Case 1
        'do nothing
    Case 2
        'do nothing
    Case 3
        'do nothing
    Case 4
        Level(NewX, NewY) = 0
        Level(OldX, OldY) = ForceConst
    Case 5
        'do nothing
    Case 6
        'do nothing
    Case 7
        'do nothing
    Case 8
        PushBlock NewX, NewY - 1, NewX, NewY, 8
        If Level(OldX, OldY) = 2 Then
            Level(OldX, OldY) = ForceConst
        End If
    Case 9
        PushBlock NewX + 1, NewY, NewX, NewY, 9
        If Level(OldX, OldY) = 2 Then
            Level(OldX, OldY) = ForceConst
        End If
    Case 10
        PushBlock NewX, NewY + 1, NewX, NewY, 10
        If Level(OldX, OldY) = 2 Then
            Level(OldX, OldY) = ForceConst
        End If
    Case 11
        PushBlock NewX - 1, NewY, NewX, NewY, 11
        If Level(OldX, OldY) = 2 Then
            Level(OldX, OldY) = ForceConst
        End If
    Case 12
        'do nothing
    Case 13
        'do nothing
    Case 14
        'do nothing
    Case 15
        Level(NewX, NewY) = 1
        Level(OldX, OldY) = ForceConst
End Select
Reload
End Sub

Private Sub Form_Load()
PictureClip1.ClipHeight = 16
PictureClip1.ClipWidth = 16
For I = 1 To 255
    Load Image1(I)
    Image1(I).Visible = True
    Image1(I).Top = I And 240
    Image1(I).Left = 16 * (I And 15)
Next I
Call OpenFile(InputBox("Filename:"))
Reload
LocateYou
End Sub

Private Sub Reload()
For I = 0 To 15
    For J = 0 To 15
        C = Level(I, J)
        If C = 16 Then
            C = 3
        End If
        PictureClip1.ClipY = 16 * (C And 3)
        PictureClip1.ClipX = 4 * (C And 12)
        Image1(I + J * 16) = PictureClip1.Clip
    Next J
Next I
End Sub

Private Sub OpenFile(filename As String)
Open filename For Binary As #1
Get #1, , Level
For I = 0 To 15
    For J = 0 To 15
        Tiles(I, J) = Level(I, J)
    Next J
Next I

Close #1
Reload
blnSaved = True
End Sub

