VERSION 5.00
Object = "{27395F88-0C0C-101B-A3C9-08002B2F49FB}#1.1#0"; "PICCLP32.OCX"
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "BlockPusher Level Editor"
   ClientHeight    =   4485
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   5520
   LinkTopic       =   "Form1"
   ScaleHeight     =   299
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   368
   StartUpPosition =   3  'Windows Default
   Begin PicClip.PictureClip PictureClip1 
      Left            =   3960
      Top             =   1680
      _ExtentX        =   1693
      _ExtentY        =   1693
      _Version        =   393216
      Picture         =   "bpedit.frx":0000
   End
   Begin VB.Image Image3 
      Height          =   240
      Left            =   4200
      Top             =   240
      Width           =   240
   End
   Begin VB.Image Image2 
      Height          =   240
      Index           =   0
      Left            =   0
      Top             =   0
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   15
      Left            =   4680
      Top             =   1320
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   14
      Left            =   4680
      Top             =   1080
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   13
      Left            =   4680
      Top             =   840
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   12
      Left            =   4680
      Top             =   600
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   11
      Left            =   4440
      Top             =   1320
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   10
      Left            =   4440
      Top             =   1080
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   9
      Left            =   4440
      Top             =   840
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   8
      Left            =   4440
      Top             =   600
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   7
      Left            =   4200
      Top             =   1320
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   6
      Left            =   4200
      Top             =   1080
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   5
      Left            =   4200
      Top             =   840
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   4
      Left            =   4200
      Top             =   600
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   3
      Left            =   3960
      Top             =   1320
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   2
      Left            =   3960
      Top             =   1080
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   1
      Left            =   3960
      Top             =   840
      Width           =   240
   End
   Begin VB.Image Image1 
      Height          =   240
      Index           =   0
      Left            =   3960
      Top             =   600
      Width           =   240
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuNew 
         Caption         =   "&New"
      End
      Begin VB.Menu mnuOpen 
         Caption         =   "&Open"
      End
      Begin VB.Menu mnuSave 
         Caption         =   "&Save"
      End
      Begin VB.Menu mnuSaveAs 
         Caption         =   "Save As"
      End
      Begin VB.Menu mnuExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False


'tiles
'0=floor
'1=wall
'2=block
'3=you
'4=water
'5=exit
'6="real" wall
'7="fake" wall
'8=force n
'9=force e
'10=force s
'11=force w
'12=inv wall
'13=hidden wall
'14=popup wall
'15=blocktrap
Dim Tiles(15, 15) As Byte
Dim CurrentTile As Byte
Dim blnSaved As Boolean
Dim FileName As String

Private Sub Form_Load()
PictureClip1.ClipHeight = 16
PictureClip1.ClipWidth = 16
For I = 1 To 255
    
    Load Image2(I)
    Image2(I).Visible = True
    Image2(I).Top = I And 240
    Image2(I).Left = 16 * (I And 15)
Next I
For I = 0 To 15
    With PictureClip1
        .ClipY = 16 * (I And 3)
        .ClipX = 4 * (I And 12)
        Image1(I).Picture = PictureClip1.Clip
    End With
Next I
Reload
Image3.Picture = Image1(0).Picture
blnSaved = True
End Sub

Private Sub Reload()
For I = 0 To 15
    For J = 0 To 15
        C = Tiles(I, J)
        C = C And 15
        Image2(I + J * 16).Picture = Image1(C).Picture
    Next J
Next I
End Sub

Private Sub Form_Unload(Cancel As Integer)
Dim retval As Integer
If blnSaved = False Then
retval = MsgBox("Do you want to save?", vbYesNoCancel, "BlockPusher Editor")
Select Case retval
    Case vbYes
        mnuSave_Click
    Case vbNo
        'do nothing
    Case vbCancel
        Cancel = 1
End Select
End If
End Sub

Private Sub Image1_Click(Index As Integer)
CurrentTile = Index
Image3.Picture = Image1(Index).Picture
End Sub


Private Sub Image2_Click(Index As Integer)
Dim X%, Y%
Y = (Index And 240) \ 16
X = Index And 15
Tiles(X, Y) = CurrentTile
Image2(Index).Picture = Image1(CurrentTile).Picture
blnSaved = False
End Sub

Private Sub mnuExit_Click()
Unload Me
End
End Sub

Private Sub mnuNew_Click()
Dim retval As Integer
If blnSaved = False Then
retval = MsgBox("Do you want to save?", vbYesNoCancel, "BlockPusher Editor")
Select Case retval
    Case vbYes
        mnuSave_Click
    Case vbNo
        'do nothing
    Case vbCancel
        Exit Sub
End Select
End If
FileName = ""
For I = 0 To 15
    For J = 0 To 15
        Tiles(I, J) = 0
    Next J
Next I
Reload
blnSaved = True
End Sub

Private Sub mnuOpen_Click()
FileName = InputBox("Filename:", "BlockPusher Editor")
If FileName = "" Then
    Exit Sub
End If

Open FileName For Binary As #1
Get #1, , Tiles
Close #1
Reload
blnSaved = True
End Sub

Private Sub mnuSave_Click()
If FileName = "" Then
    FileName = InputBox("Filename:", "BlockPusher Editor")
End If
If FileName = "" Then
    Exit Sub
End If
Open FileName For Binary As #1
Put #1, , Tiles
Close #1
blnSaved = True
End Sub

Private Sub mnuSaveAs_Click()
FileName = InputBox("Filename:", "BlockPusher Editor")
If FileName = "" Then
    Exit Sub
End If
Open FileName For Binary As #1
Put #1, , Tiles
Close #1
blnSaved = True
End Sub
